﻿using System;
using System.Linq;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace i8017HW_Basic_Info_Csharp
{
    public partial class Form1 : Form
    {
        private string[] jumperStr = new string[2];
        int s17;
        int chs;
        int gain;
        TextBox[] gval_arr = new TextBox[5];
        TextBox[] oval_arr = new TextBox[5];
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            cboSlotIndex.Items.Clear();
            cboSlotIndex.Items.Add("Slot 0");
            cboSlotIndex.Items.Add("Slot 1");
            cboSlotIndex.Items.Add("Slot 2");
            cboSlotIndex.Items.Add("Slot 3");
            cboSlotIndex.Items.Add("Slot 4");
            cboSlotIndex.Items.Add("Slot 5");
            cboSlotIndex.Items.Add("Slot 6");
            cboSlotIndex.Items.Add("Slot 7");

            jumperStr[0] = "Differential";
            jumperStr[1] = "Single Ended";

            cboRange.Items.Clear();
            cboRange.Items.Add("Voltage +/- 10.0 V ");
            cboRange.Items.Add("Voltage +/-  5.0 V ");
            cboRange.Items.Add("Voltage +/-  2.5 V ");
            cboRange.Items.Add("Voltage +/-  1.25 V ");
            cboRange.Items.Add("Current +/- 20.0 mA ");
            cboRange.Enabled = false;

            gval_arr[0] = textBox1;
            gval_arr[1] = textBox3;
            gval_arr[2] = textBox5;
            gval_arr[3] = textBox7;
            gval_arr[4] = textBox9;

            oval_arr[0] = textBox2;
            oval_arr[1] = textBox4;
            oval_arr[2] = textBox6;
            oval_arr[3] = textBox8;
            oval_arr[4] = textBox10;

            btnAI.Enabled = false;
        }

        private void cboSlotIndex_SelectedIndexChanged(object sender, EventArgs e)
        {
            Int16 ifSingleEnded = 0;
            Int16 firmware = 0;
            Int16 i = 0;
            UInt16 gval = 0;
            Int16 oval = 0;
            short ret = 0;
            s17 = cboSlotIndex.SelectedIndex;
            if ((ret = pac8017HWNet.pac8017HW.Init(s17)) != 0)
            {
                MessageBox.Show(string.Format("No I-8017HW Series modules at slot {0} {1}", s17, ret));
                return;
            }
            txtLibVer.Text = String.Format("{0:X4}", pac8017HWNet.pac8017HW.LibVersion());
            txtLibDate.Text = pac8017HWNet.pac8017HW.LibDate();
            pac8017HWNet.pac8017HW.FirmwareVersion(s17, ref firmware);
            txtFirmware.Text = String.Format("{0:X4}", firmware);
            pac8017HWNet.pac8017HW.SingleEndJumper(s17, ref ifSingleEnded);
            txtJumper.Text = jumperStr[ifSingleEnded];
            if (ifSingleEnded == 1)
            {
                chs = 16;
            }
            else
            {
                chs = 8;
            }
            for (i = 0; i < 5; i++)
            {
                pac8017HWNet.pac8017HW.GainOffset_Info(s17, i, ref gval, ref oval);
                gval_arr[i].Text = gval.ToString();
                oval_arr[i].Text = oval.ToString();
            }
            cboRange.Enabled = true;
        }

        private void cboRange_SelectedIndexChanged(object sender, EventArgs e)
        {
            btnAI.Enabled = true;
            gain = cboRange.SelectedIndex;
        }

        private void btnAI_Click(object sender, EventArgs e)
        {
            Int16 ret;
            TextBox[] aiText = new TextBox[] { txtAI00, txtAI01, txtAI02, txtAI03, txtAI04, txtAI05, txtAI06, txtAI07, txtAI08, txtAI09, txtAI10, txtAI11, txtAI12, txtAI13, txtAI14, txtAI15 };
            float fValue = 0;
            Int16 iValue = 0;
            string valStr;

            int ch;
            for (ch = 0; ch < chs; ch++)
            {
                if (frdo.Checked == true)
                {
                    ret = pac8017HWNet.pac8017HW.ReadAI(s17, ch, gain, ref fValue);
                    valStr = String.Format("{0:00.000}", fValue);
                    aiText[ch].Text = valStr;
                }
                else
                {
                    ret = pac8017HWNet.pac8017HW.ReadAIHex(s17, ch, gain, ref iValue);
                    valStr = String.Format("{0:X4}", iValue);
                    aiText[ch].Text = valStr;
                }
            }
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
    }
}